<?php
/*
Plugin Name: TweetThis
Version: auto
Description: Add a "Tweet This" button on picture pages
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=560
Author: Mistic
Author URI: http://www.strangeplanet.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('TWEET_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

load_language('plugin.lang', TWEET_PATH);
add_event_handler('loc_end_picture', 'tweet_add_button');
add_event_handler('loc_end_index', 'tweet_add_button');


function tweet_add_button() 
{
  global $conf, $template;
  $conf['TweetThis'] = explode(',', $conf['TweetThis']);
  
  if (script_basename() == 'picture')
  {
    $template->assign(array(
      'TWEET_IMAGE' => $conf['TweetThis'][0],
      'TWEET_POSITON' => $conf['TweetThis'][1],
    ));
        
    $template->set_prefilter('picture', 'tweet_add_button_prefilter');
  }
  else if (script_basename() == 'index')
  {
    $template->assign(array(
      'TWEET_IMAGE' => $conf['TweetThis'][0],
      'TWEET_POSITON' => 'index',
    ));
        
    $template->set_prefilter('index', 'tweet_add_button_prefilter');
  }
}

function tweet_add_button_prefilter($content, &$smarty)
{
  global $template;
  
  switch ($template->get_template_vars('TWEET_POSITON'))
  {
    case 'top':
      $search = '<div id="theImage">';
      $replace = '
<a href="http://twitter.com/share" class="twitter-share-button" title="{\'Share on Twitter\'|@translate}" style="display:block;">
  <img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>
</a>
';
      break;
      
    case 'bottom':
      $search = '{$ELEMENT_CONTENT}';
      $replace = '
<a href="http://twitter.com/share" class="twitter-share-button" title="{\'Share on Twitter\'|@translate}" style="display:block;">
  <img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>
</a>
';
      break;
      
    case 'toolbar':
      $search = '{/if}{/strip}{*caddie management END*}';
      $replace = '
<a href="http://twitter.com/share" class="twitter-share-button pwg-button" title="{\'Share on Twitter\'|@translate}">
  <img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>
</a>
';
      break;
      
    case 'index':
      $search = '<ul class="categoryActions">';
      $replace = '
<li><a href="http://twitter.com/share" class="twitter-share-button pwg-button" title="{\'Share on Twitter\'|@translate}">
  <img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>
</a></li>
';
      break;
  }
  
  $replace = $search . $replace . '{combine_script id=\'twitter_widgets\' path=\'http://platform.twitter.com/widgets.js\'}';

  return str_replace($search, $replace, $content);
}


if (script_basename() == 'admin')
{
  add_event_handler('get_admin_plugin_menu_links', 'tweet_plugin_admin_menu');

  function tweet_plugin_admin_menu($menu)
  {
    array_push(
      $menu,
      array(
        'NAME' => 'TweetThis',
        'URL' => get_root_url().'admin.php?page=plugin-'.basename(dirname(__FILE__))
        )
      );
    
    return $menu;
  }
}

?>